using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using Hncore.Infrastructure.Common;
using Hncore.Infrastructure.Data;
using Hncore.Infrastructure.Serializer;
using Hncore.Pass.PaymentCenter.WeiFuTong.QueryOrder;
using Hncore.Pass.PaymentCenter.WeiFuTong.SwipeCard;

namespace Hncore.Pass.PaymentCenter.WeiFuTong.ClientExtension
{
    public static class QueryOrderExt
    {
        /// <summary>
        /// 支付订单查询
        /// </summary>
        /// <param name="weiFuTongClient"></param>
        /// <param name="request"></param>
        /// <returns></returns>
        public static async Task<WeiFuTongQueryOrderResponse> QueryOrderAsync(this WeiFuTongClient weiFuTongClient
            , WeiFuTongQueryOrderRequest request)
        {
            StringBuilder log = new StringBuilder();

            var body = request.ToXml();

            log.Append("请求：\r\n" + body);

            var response = await weiFuTongClient.CreateHttpClient()
                .PostAsync(request.PaymentChannel.GetUrl(), new StringContent(body));

            var resText = await response.Content.ReadAsStringAsync();

            log.Append("\r\n响应：" + resText);
            
            //LogHelper.Trace("威富通支付订单查询", log.ToString());

            if (response.StatusCode != HttpStatusCode.OK)
            {
                throw new HttpException(response.StatusCode) {Content = resText};
            }

            Util.CheckSignFromXml(resText, request.MchInfo);

            return XML.XmlDeserialize<WeiFuTongQueryOrderResponse>(resText);
        }
    }
}